<?php
/**
* @version $Id: controller.php $
* @version		1.4.2 23/08/2019
* @package		bsbanner
* @author       Bernard Saulmé
* @copyright	Copyright (C) 2008 - 2019 Bernard Saulmé
* @license      GNU/GPLv3 http://www.gnu.org/licenses/gpl-3.0.html
*/

defined('_JEXEC') or die;
require_once JPATH_COMPONENT_SITE.'/helpers/util.php';

class BsbannerController extends JControllerLegacy
{
	function display($cachable = false, $urlparams = false)
	{
		// Load & add the menu
		require_once JPATH_COMPONENT.'/helpers/bsbanner.php';

		$jinput = JFactory::getApplication()->input;
		BsBannerHelper::addSubmenu($jinput->get('view', 'bsbanner', 'STRING'));

		parent::display();
	}

	// Unzip plugin file in the plugin folder
	function instplug()
	{
		JSession::checkToken('post') or jexit(JText::_('JINVALID_TOKEN'));

		$retour = 0;

		if (isset($_FILES['userfile']['tmp_name'])) {
			$file_tmp = $_FILES['userfile']['tmp_name'];
			$zip = new ZipArchive;
			if ($zip->open($file_tmp) === TRUE) {
				$zip->extractTo(JPATH_COMPONENT_SITE.'/plugin');
				$zip->close();
				$retour = 1;
			} else {
				$retour = 0;
			}
			@unlink($_FILES['userfile']['tmp_name']);
		}

		if ($retour == 1)
			$this->setRedirect(JRoute::_('index.php?option=com_bsbanner&view=plugin',false), JText::_('COM_BSBANNER_PLUGIN_UPLOAD_OK'), 'message');
		else
			$this->setRedirect(JRoute::_('index.php?option=com_bsbanner&view=plugin',false), JText::_('COM_BSBANNER_PLUGIN_UPLOAD_KO'), 'error');
	}
	
	// Delete a plugin forder
	function delplug()
	{
		JSession::checkToken('post') or jexit(JText::_('JINVALID_TOKEN'));

		$jinput = JFactory::getApplication()->input;
		$plugin = $jinput->get('plugin', '', 'STRING');
		if ($plugin == '' || $plugin == '.')
			$retour = 0;
		else
			$retour = clear_dir(JPATH_COMPONENT_SITE.'/plugin/'.$plugin);

		if ($retour == 1)
			$this->setRedirect(JRoute::_('index.php?option=com_bsbanner&view=plugin',false), JText::sprintf('COM_BSBANNER_PLUGIN_DEL_OK', $plugin), 'message');
		else
			$this->setRedirect(JRoute::_('index.php?option=com_bsbanner&view=plugin',false), JText::sprintf('COM_BSBANNER_PLUGIN_DEL_KO', $plugin), 'error');
	}

	// Reset configuration
	function resetconf()
	{
		JSession::checkToken('post') or jexit(JText::_('JINVALID_TOKEN'));

		@copy(JPATH_COMPONENT_SITE.'/models/#ref-image.conf2_model.php', JPATH_COMPONENT_SITE.'/models/#ref-image.conf2.php');
		
		$this->setRedirect(JRoute::_('index.php?option=com_bsbanner&view=param',false), JText::sprintf('COM_BSBANNER_RESET_DONE', $plugin), 'message');
	}
}
?>
