<?php
/**
* @version $Id: default.php $
* @version		1.4.2 23/08/2019
* @package		bsbanner
* @author       Bernard Saulmé
* @copyright	Copyright (C) 2008 - 2019 Bernard Saulmé
* @license      GNU/GPLv3 http://www.gnu.org/licenses/gpl-3.0.html
*/

defined('_JEXEC') or die;

$document = JFactory::getDocument();
$document->addStyleSheet(JURI::root(true).'/components/com_bsbanner/assets/bsbanner-back.css');

?>
<div class="bsbanner <?php if (version_compare(JVERSION, '3.99.99', 'lt')) {echo "";} else {echo "row";} ?>">
<?php if (isset($this->sidebar)) { ?>
	<div id="j-sidebar-container" class="col-md-2">
		<?php echo $this->sidebar; ?>
	</div>
<?php } ?>
	<div id="j-main-container" class="j-main-container col-md-12">

	<fieldset class="adminform">
	<legend class="title-back"><span class="icon-power-cord"></span> <?php echo JText::_('COM_BSBANNER_PLUGIN_LIST');?></legend>
		<form method="post" action="<?php echo JRoute::_('index.php'); ?>" >
<?php
	$nb = count($this->tab_list_dir);
	if ($nb == 0) {
		echo JText::_('COM_BSBANNER_PLUGIN_NO_PLUGIN').'<br />';
	} else {
		for ($i = 0 ; $i < $nb ; ++$i) {
			$comment = '';
			if ($this->tab_list_dir[$i] == 'plug_data_default')
				$comment = ' '.JText::_('COM_BSBANNER_PLUGIN_MODEL');

			if ('plug_'.$this->plugin == $this->tab_list_dir[$i])
				$comment .= ' '.JText::_('COM_BSBANNER_PLUGIN_ACTIVE');

			echo '<label for="i'.$i.'" style="margin: 0"><input type="radio" id="i'.$i.'" name="plugin" value="'.$this->tab_list_dir[$i].'" /> '.str_replace('plug_', '', $this->tab_list_dir[$i]).$comment.'</label><br />';
		}
?>
			<input name="option" type="hidden" value="com_bsbanner" />
			<input name="task" type="hidden" value="delplug" />
			<button class="btn btn-danger">
				<span class="icon-trash"></span>
				<?php echo JText::_('COM_BSBANNER_PLUGIN_DELETE') ?>
			</button>
<?php } ?>
		<?php echo JHtml::_('form.token'); ?>
		</form>
	</fieldset>
	<br />

	<form method="post" action="<?php echo JRoute::_('index.php'); ?>" enctype="multipart/form-data" id="upload_file_form">
		<fieldset class="adminform">
			<legend class="title-back"><span class="icon-upload"></span> <?php echo JText::_('COM_BSBANNER_PLUGIN_UPLOAD');?></legend>
			<input name="option" type="hidden" value="com_bsbanner" />
			<input name="task" type="hidden" value="instplug" />
			<input type="file" name="userfile" onchange="document.getElementById('upload_file_form').submit();" />
			<input type="hidden" name="MAX_FILE_SIZE" value="1048576" />
			<button class="btn btn-success" >
				<span class="icon-upload"></span>
				<?php echo JText::_('COM_BSBANNER_PLUGIN_UPLOAD'); ?>
			</button>
		</fieldset>

		<?php echo JHtml::_('form.token'); ?>
	</form>

	<br />
	</div>
</div>
