<?php
/**
* @version $Id: bsbanner.php $ 
* @version		1.4.2 01/06/2019
* @package		plg_system_myjspace
* @author       Bernard Saulmé
* @copyright	Copyright (C) 2019 Bernard Saulmé
* @license      GNU/GPLv3 http://www.gnu.org/licenses/gpl-3.0.html
*/

defined('_JEXEC') or die();

use Joomla\CMS\Factory;
use Joomla\CMS\Language\Text;

/**
 * Class plgSystemBSBanner
 * @since BS Banner
 */
class plgSystemBSBanner extends \Joomla\CMS\Plugin\CMSPlugin
{
	protected $autoloadLanguage = true;

	/**
	 * @param   object $subject Subject
	 * @param   array  $config  Config
	 *
	 * @throws Exception
	 * @since BS Banner
	 */
	public function __construct(&$subject, $config)
	{
		// Do not load if BS Banner not installed
		if (!@file_exists(JPATH_ROOT.'/components/com_bsbanner/bsbanner.php')) {
			return;
		}

		parent::__construct($subject, $config);
	}

	/**
	 * Adds the BS Banner Privacy Information to Joomla Privacy plugin.
	 *
	 * @return array
	 *
	 * @since BS Banner 1.4.1
	 */
	public function onPrivacyCollectAdminCapabilities()
	{
		$this->loadLanguage();

		return(array(
			Text::_('PLG_SYSTEM_BSBANNER_PRIVACY') => array(
				Text::_('PLG_SYSTEM_BSBANNER_PRIVACY_CAPABILITY_USERPROFILE'),
				Text::_('PLG_SYSTEM_BSBANNER_PRIVACY_CAPABILITY_PAGES'),
				Text::_('PLG_SYSTEM_BSBANNER_PRIVACY_CAPABILITY_MORE')
			),
		));
	}
}
