<?php
/**
* @version $Id: util.php $
* @version		1.4.2 23/08/2019
* @package		bsbanner
* @author       Bernard Saulmé
* @copyright	Copyright (C) 2008 - 2019 Bernard Saulmé
* @license      GNU/GPLv3 http://www.gnu.org/licenses/gpl-3.0.html
*/

defined('_JEXEC') or die;

// Directory list of dir
function list_dir_dir($rep, $allowed_types = null, $forbiden_files = null, $sort = 0) {

	$tab_retour = array();

	@chdir($rep);
	if ($dir = @opendir('.')) {
		while (false !== ($File = @readdir($dir))) {
			$path_parts = strtolower(pathinfo($File, PATHINFO_EXTENSION));
			if (@is_dir($File) && ($allowed_types[0] == '*' || in_array($path_parts, $allowed_types)) && (!in_array(strtolower($File), $forbiden_files))) {
				$tab_retour[] = $File;
			}
		}
		@closedir($dir);
	}

	if ($sort == 1)
		sort($tab_retour);

	return $tab_retour;
}

// Delete a folder and sub folders
function clear_dir($dossier) {

	$oldfolder = getcwd();
	if (!@chdir($dossier))
		return;

	$ouverture = @opendir($dossier);
	if (!$ouverture) {
		@chdir($oldfolder);
		return;
	}
	while($fichier = @readdir($ouverture)) {
		if ($fichier != '.' && $fichier != '..') {
			if (@is_dir($dossier.'/'.$fichier)) {
				$r = clear_dir($dossier.'/'.$fichier);
				if (!$r) {
					@chdir($oldfolder);
					return false;
				}
			}
			else {
				$r = @unlink($dossier.'/'.$fichier);
				if (!$r) {
					@chdir($oldfolder);
					return false;
				}
			}
		}
	}
	@closedir($ouverture);
	$r = (@rmdir($dossier) || @rename($dossier.'/'.$fichier, JPATH_ROOT.'/tmp/#tobedeleted')); // rename '#tobedeleted' in case of hosting not allow folder deletion
	if (!$r) {
		@chdir($oldfolder);
		return false;
	}
	@chdir($oldfolder);

	return true;
}

?>
