<?php
/**
* @version $Id: bsbanner.php $
* @version		1.4.2 23/08/2019
* @package		bsbanner
* @author       Bernard Saulmé
* @copyright	Copyright (C) 2008 - 2019 Bernard Saulmé
* @license      GNU/GPLv3 http://www.gnu.org/licenses/gpl-3.0.html
*/

defined('_JEXEC') or die;

// Inclue la fonction de dessin de vignette
require_once JPATH_COMPONENT_SITE.'/models/fct_vignette.php';

class BsbannerModelBsbanner extends JModelLegacy
{
	// Recupère le répertoire de sauvegarde des vignettes
	function rep_img() {

		$pparams = JComponentHelper::getParams('com_bsbanner');
		$rep = JPATH_BASE.'/'.$pparams->get('fichier_image_rep', 'images/');

		return($rep);
	}

	// Recupere les parametres de la vignette (config administrator + ajout choix par defaut)
	public static function charge_param() {

		$pparams = JComponentHelper::getParams('com_bsbanner');

		$maparam = array();

		$maparam['image_x'] = $pparams->get('image_x', '330');
		$maparam['image_y'] = $pparams->get('image_y', '60');
		$maparam['titre_1'] = $pparams->get('titre_1', '#1');
		$maparam['titre_11'] = $pparams->get('titre_11', '#2');
		$maparam['titre_2'] = $pparams->get('titre_2', '#3');
		$maparam['image_transparente'] = $pparams->get('image_transparente', '0');
		$maparam['image_publique'] = $pparams->get('image_publique', '1');
		$maparam['image_fichier'] = 1;
		$maparam['image_couleur_ok'] = $pparams->get('image_couleur_ok', '336699');
		$maparam['image_couleur_fond'] = $pparams->get('image_couleur_fond', 'EAEAEA');
		$maparam['image_couleur_texte'] = $pparams->get('image_couleur_texte', '0000FF');
		$maparam['image_couleur_fond_url'] = $pparams->get('image_couleur_fond_url', 'http://');
		$maparam['fichier_image_rep'] = $pparams->get('fichier_image_rep', 'images/');
		$maparam['image_fond'] = '';
		$maparam['image_fond_util'] = $pparams->get('image_fond_util', '307200');
		$maparam['image_fond_util_url'] = $pparams->get('image_fond_util_url', '307200');
		$maparam['archive_data_user_cookie'] = $pparams->get('archive_data_user_cookie', '1');
		$maparam['plugin'] = $pparams->get('plugin', 'data_default');
		$maparam['convertir_latin_utf8'] = $pparams->get('convertir_latin_utf8', '1');
	//	$maparam['mon_site_aff_pub'] = $pparams->get('mon_site_aff_pub', '');
		$maparam['nb_instance'] = $pparams->get('nb_instance', '1');
		$maparam['archive_data_user_nb'] = $pparams->get('archive_data_user_nb', '200');
		$maparam['archive_data_user_days'] = $pparams->get('archive_data_user_days', '365');

		$maparam['kunena_add_signature'] = $pparams->get('kunena_add_signature', 0);
		if ($maparam['kunena_add_signature'] > 0 && !@is_file(JPATH_ADMINISTRATOR.'/components/com_kunena/api.php')) // selected & kunena installed
			$maparam['kunena_add_signature'] = 0;
		$maparam['kunena_add_signature_choice'] = $pparams->get('kunena_add_signature_choice', 2); // 0 n'ajoute pas, 1 remplace signature, 2 ajoute à la fin (si pas déjà)

		return($maparam);
	}

	// Surcharge : Valeurs par defaut (remplacement des #1, #2, #3, #4, #5 par leur valeurs)
	function maparam_surcharge($valeur_tmp, $autre, $instance = '', $date = '') {

		$valeur_tmp = str_replace('#1', $autre, $valeur_tmp);
		$valeur_tmp = str_replace('#2', $instance, $valeur_tmp);
		$valeur_tmp = str_replace('#3', $date, $valeur_tmp);
		$date_tab = explode(" ", $date); // Pourrait être plus sophistiqué et/ou avoir un format variable
		$valeur_tmp = str_replace('#4', $date_tab[0], $valeur_tmp);
		$valeur_tmp = str_replace('#5', 'http://'.$_SERVER["SERVER_NAME"], $valeur_tmp);

		return($valeur_tmp);
	}

	// Charge le fichier de donnees de seuils si existe
	function charge_seuil($id_param) {

		$maconf = array();

		$fichier_include = JPATH_COMPONENT_SITE.'/models/'.$id_param.'-image.conf2.php';
		if (@file_exists($fichier_include))
			require_once $fichier_include;
		else {
			$maconf = array();
			$maconf[1]['id'] = '';
			$maconf[1]['img'] = 1;
		}

		return($maconf);
	}

	// Recup. les valeurs pour images du GET($param_tmp) (pour idX et dataX) et les mets dans un tableau
	function charge_data($param_tmp) {

		$madata = array();
		foreach($param_tmp as $cle=>$valeur) {
			if (substr($cle, 0, 10) == 'jform_date') {
				$id_data = substr($cle, 10);
				$madata[$id_data]['date'] = $valeur;
			}
			if (substr($cle, 0, 2) == 'id') {
				$id_data = substr($cle, 2);
				$madata[$id_data]['id'] = $valeur;
				$madata[$id_data]['img'] = '0'; // Valeur par defaut (donc mettre apres id dans formulaire), necessite que la case a cocher apparasse apres id dans formulaire
			}
			if (substr($cle, 0, 4) == 'data') {
				$id_data = substr($cle, 4);
				$madata[$id_data]['data'] = $valeur;
			}
			if (substr($cle, 0, 3) == 'img') {
				$id_data = substr($cle, 3);
				$madata[$id_data]['img'] = $valeur;
			}
		}

		return($madata);
	}

	// Image en cas de problème !
	function affiche_image_ko() {
	}

	// Créé une image avec les données utilisateur et la sauvegarde en fichier
	function cree_image_fichier($user, $param_tmp) {

		// Charge les valeurs de configuration des seuils
		$maconf = $this->charge_seuil('#ref');
		$id_param = $user->username;

		// EVOL : charger les valeurs perso/utilisateur de config

		// Répère les données saisies (date, id, data, img) par l'utilisateur (source = saisies : POST)
		$madata = $this->charge_data($param_tmp);

		// Charge les paramètres génériques pour la création de l'image
		$maparam = $this->charge_param($id_param);

		if (!isset($id_param) || count($maconf) <= 0 || count($madata) <= 0 || count($maparam) <= 0) {
			$this->affiche_image_ko();
			return(0);
		}

		// Validation des saisies : format de date et transforme au format 'Y-m-d H:i:s', longeurs et typage
		$madata = $this->valid_data($madata, JText::_('BSBNR_DATE_CALENDAR'), 0);

		// Traitement des Parametres saisies
		// Affectation image utilisateur si autorisé et existante
		if (isset($maparam['image_fond_util']) && $maparam['image_fond_util'] >= 1 && isset($_FILES['userfile']['tmp_name']) && !($_FILES['userfile']['error']))
			$maparam['image_fond'] = $_FILES['userfile']['tmp_name'];
		// Couleur texte
		if (isset($param_tmp['image_couleur_texte']))
			$maparam['image_couleur_texte'] = substr($param_tmp['image_couleur_texte'], 0, 6);
		// Couleur fond
		if (isset($param_tmp['image_couleur_fond']))
			$maparam['image_couleur_fond'] = substr($param_tmp['image_couleur_fond'], 0, 6);
		// Fond transparent
		if (isset($param_tmp['image_transparente']))
			$maparam['image_transparente'] = $param_tmp['image_transparente'];
		else
			$maparam['image_transparente'] = 0;
		// Instance
		if (isset($param_tmp['instance']))
			$maparam['instance'] = $param_tmp['instance'];
		else
			$maparam['instance'] = 1;

		// Surcharge : Valeurs par defaut (remplacement des #1, #2, #3, #4, #5 par leur valeur)
		$maparam['titre_1'] = $this->maparam_surcharge($maparam['titre_1'], $id_param, $maparam['instance'], $madata[1]['date'].'  ');
		$maparam['titre_11'] = $this->maparam_surcharge($maparam['titre_11'], $id_param, $maparam['instance'], $madata[1]['date'].'  ');
		$maparam['titre_2'] = $this->maparam_surcharge($maparam['titre_2'], $id_param, $maparam['instance'], $madata[1]['date'].'  ');

		// Nom de fichier image, résultant
		$maparam['fichier_image'] = JPATH_BASE.'/'.$maparam['fichier_image_rep'].$id_param.'-'.$maparam['instance'].'.png';

		// Téléchargement du fichier si en url
		if (isset($maparam['image_fond_util_url']) && $maparam['image_fond_util_url'] >= 1 && isset($param_tmp['image_couleur_fond_url']) && $param_tmp['image_couleur_fond_url'] != '' && $param_tmp['image_couleur_fond_url'] != 'http://') {
		$maparam["image_fond"] = tempnam(JPATH_BASE.'/tmp', 'bsbanner'.$id_param);
		if ($this->lecture_file_url($param_tmp['image_couleur_fond_url'], $maparam['image_fond'], $maparam['image_fond_util_url']) == 0)
			$maparam['image_fond'] = null; // EVOL : ajouter un test et msg (image non comforme ou plus grosse que max)!
		}

		// Création de l'image de la 'Vignette'
		affiche_image($maconf, $maparam, $madata);

		// Sup. fichier temp. de l'image de fond
		if (@file_exists($maparam['image_fond']))
			@unlink($maparam['image_fond']);

		// Sauvegarde des saisies dans des cookies
		if ($maparam['archive_data_user_cookie'] == 1) {
			// Id de cookie pour personalisation
			$id_cookie = $id_param.'-'.$maparam['instance'].'-';

			$expire = time()+60*60*24*60; // 60 jours => EVOL mettre en parametre
			$nb_data = count($madata);
			for ($i = 1 ; $i <= $nb_data ; ++$i) {
				if ($madata[$i]['id'] != '' && $madata[$i]['data'] != '')
					setcookie($id_cookie.$madata[$i]['id'], $madata[$i]['data'], $expire, '/');
				else { // Supprime les vieux cookies eventuels de la précédente valeur
					if ($madata[$i]['id'] != '')
						setcookie($id_cookie.$madata[$i]['id']);
				}
			}

			setcookie($id_param.'-instance', $maparam['instance'], $expire, '/');
			setcookie($id_cookie.'image_couleur_texte', $maparam['image_couleur_texte'], $expire, '/');
			setcookie($id_cookie.'image_couleur_fond', $maparam['image_couleur_fond'], $expire, '/');
			setcookie($id_cookie.'image_transparente', $maparam['image_transparente'], $expire, '/');
			setcookie($id_cookie.'image_couleur_fond_url', $param_tmp['image_couleur_fond_url'], $expire, '/');
		}

		// Chargement du plugin
		$plugin_file = JPATH_COMPONENT_SITE.'/plugin/plug_data_default/data_default.php';
		if (@file_exists($plugin_file))
			require_once $plugin_file;
		// Chosen plugin
		$plugin_file = JPATH_COMPONENT_SITE.'/plugin/plug_'.$maparam['plugin'].'/'.$maparam['plugin'].'.php';
		if (@file_exists($plugin_file)) {
			require_once $plugin_file;

			$nom_class = 'BS_'.$maparam['plugin'];
			$mon_obj = new $nom_class;
			$madata = $this->valid_data($madata, JText::_('BSBNR_DATE_CALENDAR'), 1);
			$mon_obj->save_data_format($madata, $user->id, $maparam['instance']);
			$mon_obj->delete_exta_data($user->id, $maparam['archive_data_user_days'], $maparam['archive_data_user_nb']);
		}

		$madata = null; // liberation du tableau

		return($maparam['instance']);
	}

	// Supprimer le fichier de la bannière
	function supp_image_fichier($id_param, $instance = '1') {

		$img_file_rep = $this->rep_img().$id_param.'-'.$instance.'.png';
		$retour = @unlink($img_file_rep);

		return $retour;
	}

	// Lecture d'un fichier (image) à partir d'une url et copie en fichier local (taille max à spécifier)
	function lecture_file_url($url_tmp, $fichier_tmp, $taille_max_tmp) {
		$fichier = "";

		// Lecture
		if (!$fp = @fopen($url_tmp, "r"))
			return 0;

		while(!feof($fp)) {
			// On récupère une bout
			$ligne = fgets($fp, 1024);

			// On stocke l'ensemble des lignes dans une variable
			$fichier .= $ligne;

			// Teste de la taille (test modulo 1024 mais suffisant pour éviter les maxi débordements)
			if (strlen($fichier) > $taille_max_tmp)
				return 0;
		}
		@fclose($fp);

		// Sauvegarde
		if (!$fp = @fopen($fichier_tmp, "w"))
			return 0;
		@fwrite($fp, $fichier);
		@fclose($fp);

		return 1;
	}

	// Validation du format de date et transforme au format 'Y-m-d H:i:s', des longeurs et typage
	// 	si date pas saisie pour toute prend la première, si pas ok alors prend 'maintenant'
	function valid_data(&$madata = null, $date_fmt = 'Y-m-d H:i:s', $transform = 0) {

		$nb_data = count($madata);
		for ($i = 1; $i <= $nb_data; ++$i) {
			if (isset($madata[$i]['data']) && $madata[$i]['data'] != '') {
				//* Pour les dates
				if (isset($madata[$i]['date']))
					$date_tmp = $madata[$i]['date'];
				else
					$date_tmp = $madata[1]['date'];
				$date_tmp = trim($date_tmp);

				if (strstr($date_fmt, '/') != false) // Cas ou on saisie date avec - au lieu de / meme si / dans format
					$date_tmp = str_replace('-', '/', $date_tmp);

				// Ca où l'heure est au format hh:mm et non hh:mm:ss
				if (substr_count($date_tmp, ':') == 1)
					$date_tmp .= ':00';

				if ($transform == 1) { // Vérification que la date est date correcte et transformation de format
					if ($date = DateTime::createFromFormat($date_fmt, $date_tmp))
						$madata[$i]['date'] = $date->format('Y-m-d H:i:s');
					else
						$madata[$i]['date'] = date('Y-m-d H:i:s'); // Maintenant

					// Sinon date-heure actuelle par défaut
					if ($madata[$i]['date'] == '1970-01-01 00:00:00' || $madata[$i]['date'] == '0000-00-00 00:00:00')
						$madata[$i]['date'] = date('Y-m-d H:i:s'); // Maintenant
				}

				// Autres
				$madata[$i]['id'] = substr(trim($madata[$i]['id']), 0, 20); // Max 20 caractères (EVOL mettre 20 en param ?)
				$madata[$i]['data'] = substr(trim($madata[$i]['data']), 0, 40); // Max 40 caractères (EVOL mettre 40 en param ?)
				$madata[$i]['img'] = intval($madata[$i]['img']); // Toujours int
			}
		}

		return($madata);
	}
}
?>
