<?php
/**
* @version $Id: fct_vignette.php $
* @version		1.4.2 23/08/2019
* @package		bsbanner
* @author       Bernard Saulmé
* @copyright	Copyright (C) 2008 - 2019 Bernard Saulmé
* @license      GNU/GPLv3 http://www.gnu.org/licenses/gpl-3.0.html
*/

// Objet : Dessine une vignette

defined('_JEXEC') or die;

// Creation et affichage ou sauvegarde de l'image
// EVOL : enlever les constantes 40, 50, ... et remplacer par des variables
function affiche_image($maconf, $maparam, $madata) {

	// $maparam['image_fichier'] = 1 : fichier, 2 : ecran, 3 : fichier & ecran
	if ($maparam['image_fichier'] == 2 || $maparam['image_fichier'] == 3)
		header("Content-type: image/png");

	/* Taille image */
	// Calcul taille fonction du nombre de carre affiches
	$compte = 0;
	$nb_data = count($madata);
	for ($i = 1 ; $i <= $nb_data ; ++$i) {
		if ($madata[$i]['img'] == 1 && $madata[$i]['data'] != '')
			$compte++;
	}
	$maparam['image_x'] = max($compte*40+2*10, $maparam['image_x']);
	// EVOL Calcul de la taille de l'image en fonction de la taille du texte de titre 1&11&2

	/* On créé l'image en vraies couleurs */
	$image = imagecreatetruecolor($maparam['image_x'], $maparam['image_y']);

	/* On charge image de fond si existe */
	$image_type = -1;
	$image_fond = null;
	$image_fond_x = null;
	$image_fond_y = null;
	if (isset($maparam['image_fond']) && @file_exists($maparam['image_fond'])) {
		list($image_fond_x, $image_fond_y, $image_type) = @getimagesize($maparam['image_fond']);
		switch ($image_type) {
			case 1: $image_fond = imagecreatefromgif($maparam['image_fond']); break;
			case 2: $image_fond = imagecreatefromjpeg($maparam['image_fond']); break;
			case 3: $image_fond = imagecreatefrompng($maparam['image_fond']); break;
			default: return; break;
		}
	}

	/* Couleur de fond */
	$color = $maparam['image_couleur_fond'];
	$rouge = hexdec(substr($color, 0, 2));
	$vert = hexdec(substr($color, 2, 2));
	$bleu = hexdec(substr($color, 4, 2));
	$couleur = imagecolorallocate($image, $rouge, $vert, $bleu);
	imagefill($image, 0, 0, $couleur);

	/* Si fond transparent */
	if ($maparam['image_transparente'] == 1)
		imagecolortransparent($image, $couleur);

	/* Copie image de fond dans image (pour conserver taillage image) */
	/* EVOL : revoir/finir code pour ratio */
	if ($image_type > 0) {
	/* Test si image de type PNG ou GIF pour conserver la transparence */
//		if (($image_type == 1) OR ($image_type==3)) {
//			imagealphablending($image, false);
//			imagesavealpha($image,true);
//			$transparent = imagecolorallocatealpha($image, 255, 255, 255, 127);
//			imagefilledrectangle($image, 0, 0, $maparam['image_x'], $maparam['image_x'], $transparent);
//		}

		/* Pour ratio */
		$image_x2 = $maparam['image_x'];
		$image_y2 = $maparam['image_x'];
/*
		if (0) {
			$ratio_orig = $image_fond_x / $image_fond_y;
			$image_x2 = $maparam['image_y'] * $ratio_orig;
//			$image_y2 = $maparam['image_x'] / $ratio_orig;
		}
*/
//		imagecopyresampled($image, $image_fond, 0, 0, 0, 0, $maparam['image_x'], $maparam['image_y'], $image_fond_x, $image_fond_y);
		imagecopyresized($image, $image_fond, 0, 0, 0, 0, $image_x2, $image_y2, $image_fond_x, $image_fond_y);
	}

	/* Textes 'titres' */
	// Couleurs textes
	$color = $maparam['image_couleur_texte'];
	$rouge = hexdec(substr($color, 0, 2));
	$vert = hexdec(substr($color, 2, 2));
	$bleu = hexdec(substr($color, 4, 2));
	$couleur_id = imagecolorallocate($image, $rouge, $vert, $bleu);
	$couleur_data = imagecolorallocate($image, 255, 255, 255);
	// Textes Top&Bottom
	if (!isset($maparam['titre_1']))
		$maparam['titre_1'] = '';
	if (!isset($maparam['titre_11']))
		$maparam['titre_11'] = '';
	if (!isset($maparam['titre_2']))
		$maparam['titre_2'] = '';
	imagestring($image, 2, 8, 5, $maparam['titre_1'], $couleur_id);
	imagestring($image, 2, $maparam['image_x'] - strlen($maparam['titre_11'])*5 - 12, 5, $maparam['titre_11'], $couleur_id);
	imagestring($image, 1, $maparam['image_x'] - strlen($maparam['titre_2'])*5 - 4, 50, $maparam['titre_2'], $couleur_id);

	/* Boucle sur les données à afficher */
	$compte = 1;
	for ($i = 1 ; $i <= $nb_data ; ++$i) {
		if ($madata[$i]['img'] == 1 && $madata[$i]['data'] != '') {
			// Encodage de caracteres
			$text_tmp = $madata[$i]['id'];
			if (isset($maparam['convertir_latin_utf8']) && $maparam['convertir_latin_utf8'] == 1) // A AMELIORER
				$text_tmp = iconv('UTF-8', 'ISO-8859-1//TRANSLIT', $text_tmp);
			// Texte identifiant (4 premieres lettres seulement)
			$text_tmp = substr($text_tmp, 0, 4);
			$len_tmp = (40-strlen($text_tmp)*10)/2;
			// Texte dans image
			imagestring($image, 3, 10+($compte-1)*41+$len_tmp, 20, $text_tmp, $couleur_id);
			// Carre de couleur
			$color = color_img($maconf, $madata[$i]['id'], $madata[$i]['data'], $maparam['image_couleur_ok']);

			$rouge = hexdec(substr($color, 0, 2));
			$vert = hexdec(substr($color, 2, 2));
			$bleu = hexdec(substr($color, 4, 2));
			$couleur_c = imagecolorallocate($image, $rouge, $vert, $bleu);
			imagefilledrectangle($image, 10+($compte-1)*41, 34, 40+($compte-1)*41, 49, $couleur_c);
			// Encodage de caracteres
			$text_tmp = $madata[$i]["data"];
			if (isset($maparam['convertir_latin_utf8']) && $maparam['convertir_latin_utf8'] == 1) // A AMELIORER
				$text_tmp = iconv('UTF-8', 'ISO-8859-1//TRANSLIT', $text_tmp);
			// Texte dans carre (4 premieres lettres seulement)
			$text_tmp = substr($text_tmp, 0, 4);
			$len_tmp = (40-strlen($text_tmp)*10)/2;
			// Texte dans image
			imagestring($image, 3, 12+($compte-1)*41+$len_tmp, 35, $text_tmp, $couleur_data);

			$compte++;
		}
	}

	/* Sauvegarder & afficher */
	if (isset($maparam['fichier_image']) && ($maparam['image_fichier'] == 1 || $maparam['image_fichier'] == 3) && $maparam['image_publique'] == 1)
		imagepng($image, $maparam['fichier_image']); // Sauvegarde
	if ($maparam['image_fichier'] == 2 || $maparam['image_fichier'] == 3)
		imagepng($image); // Renvoie une image sous format png ecran

	imagedestroy($image); // Détruit l'image, libérant ainsi de la mémoire

	return(1);
}

/* Retourne une couleur en fonction de la valeur */
function color_img(&$maconf_tmp, $id, $data, $couleur_def = '#ffffff') {
	$couleur = $couleur_def;

	$nb_conf = count($maconf_tmp);
	for ($i = 1 ; $i <= $nb_conf ; ++$i) {
		if ($maconf_tmp[$i]['id'] == $id) {
			$allowed_cond = array('<','<=','>','>=','==','===','!=','&','|','&&','||');
			if (in_array($maconf_tmp[$i]['cond'], $allowed_cond)) {
				$chaine = 'if ('.$data.' '.$maconf_tmp[$i]['cond'].' '.$maconf_tmp[$i]['val'].') { return "'.$maconf_tmp[$i]['color'] .'"; } else { return "'.$couleur.'"; }';
				$couleur = eval($chaine);
			}
		}
	}

	return $couleur;
}

?>
