<?php
/**
* @version $Id: router.php $
* @version		1.4.2 23/08/2019
* @package		com_bsbanner
* @author       Bernard Saulmé
* @copyright	Copyright (C) 2012 - 2019 Bernard Saulmé
* @license      GNU/GPLv3 http://www.gnu.org/licenses/gpl-3.0.html
*/

defined('_JEXEC') or die;

class BsBannerRouter extends JComponentRouterBase
{
	/**
	 * Build the route for the com_myspace component
	 * @param   array  &$query  An array of URL arguments
	 * @return  array  The URL arguments to use to assemble the subsequent URL.
	 *
	 * @since   J!3.3 (Deprecated in J!4 ?)
	 */
	public function build(&$query)
	{
		$segments = array();

		if (isset($query['view'])) {
			$segments[] = $query['view'];
			unset($query['view']);
		}
		if (isset($query['id'])) {
			$segments[] = $query['id'];
			unset($query['id']);
		}

		return $segments;
	}

/**
 * @param	array	A named array
 * @param	array
 *
 * Formats:
 *
 * index.php?/bsbanner/view/id/Itemid
 *
 * index.php?/bsbanner/id/Itemid
 */
	public function parse(&$segments)
	{
		$vars = array();

		// view is always the first element of the array
		$count = count($segments);

		if ($count) {
			$count--;
			$segment = array_shift($segments);
			if (is_numeric($segment)) {
				$vars['id'] = $segment;
			} else {
				$vars['view'] = $segment;
			}
		}

		if ($count) {
			// $count--; // AFAIRE a supp
			$segment = array_shift($segments) ;
			if (is_numeric($segment)) {
				$vars['id'] = $segment;
			}
		}

		if (!array_key_exists('view', $vars)) // Default view
			$vars['view'] = 'bsbanner';

		return $vars;
	}
}
?>
