<?php
/**
* @version $Id: view.html.php $
* @version		1.4.2 23/08/2019
* @package		bsbanner
* @author       Bernard Saulmé
* @copyright	Copyright (C) 2008 - 2019 Bernard Saulmé
* @license      GNU/GPLv3 http://www.gnu.org/licenses/gpl-3.0.html
*/

defined('_JEXEC') or die;

require_once JPATH_COMPONENT_SITE.'/helpers/helper.php';

class BsbannerViewBsbanner extends JViewLegacy
{
	function display($tpl = null)
	{
		$user = JFactory::getuser();
		$this->username = $user->username;

		if (isset($user->username)) {
			$pparams = JComponentHelper::getParams('com_bsbanner');
			$jinput = JFactory::getApplication()->input;

			$this->mon_site_aff_pub = $pparams->get('mon_site_aff_pub', '');
			$this->nb_instance = $pparams->get('nb_instance', 1);
			$this->section_top = $pparams->get('section_top', '');
			$this->section_bottom = $pparams->get('section_bottom', '');

			$this->inst = $jinput->get('instance', '1', 'INT');
			$img_file_rep = $pparams->get('fichier_image_rep', 'images/').$user->username.'-'.$this->inst.'.png';
			if (!@file_exists(JPATH_ROOT.'/'.$img_file_rep)) {
				$this->url_img1 = null;
				$this->url_img2 = null;
			} else {
				$heure_now = time(); // Pour forcer le rafraichissement de l'affichage de l'image
				$this->url_img1 = JURI::base().$img_file_rep;
				$this->url_img2 = $this->url_img1.'?t='.$heure_now;
			}

			// Liste des fichiers images pour l'utilisateur
			$this->list_url = null;
			if ($this->nb_instance > 1) {
				for ($i = 1 ; $i <= $this->nb_instance ; ++$i) {
					$fichier = $pparams->get('fichier_image_rep','images/').$user->username.'-'.$i.'.png';
					if (@file_exists($fichier)) {
						$url = htmlspecialchars('index.php?view=bsbanner&instance='.$i);
						$this->list_url .= '<a href="'.$url.'" >'.$i.'</a> ';
					}
				}
			}
		}

		parent::display($tpl);
	}

	function display_module($module_name, $style = 'none') {
		BS_helper::display_module($module_name, $style);
	}
}
?>
