<?php
/**
* @version $Id: view.html.php $
* @version		1.4.2 23/08/2019
* @package		bsbanner
* @author       Bernard Saulmé
* @copyright	Copyright (C) 2008 - 2019 Bernard Saulmé
* @license      GNU/GPLv3 http://www.gnu.org/licenses/gpl-3.0.html
*/

defined('_JEXEC') or die;

require_once JPATH_COMPONENT_SITE.'/helpers/helper.php';

class BsbannerViewData extends JViewLegacy
{
	function display($tpl = null)
	{
		$jinput = JFactory::getApplication()->input;
		// User info
		$user = JFactory::getuser();

		if (isset($user->username)) {
			// Config
			$pparams = JComponentHelper::getParams('com_bsbanner');

			$plugin = $pparams->get('plugin', 'data_default');
			$nb_instance = $pparams->get('nb_instance', 1);
			$archive_data_user_nb_print = $jinput->get('nbligne', 0, 'INT');
			if ($archive_data_user_nb_print == '0')
				$archive_data_user_nb_print = $pparams->get('archive_data_user_nb_print', 100);
			else
				$archive_data_user_nb_print = min($jinput->get('nbligne', 0, 'INT'), $pparams->get('archive_data_user_nb_print', 100));
			$this->section_top = $pparams->get('section_top', '');
			$this->section_bottom = $pparams->get('section_bottom', '');

			// Mode affichage
			$mode = $jinput->get('mode', '', 'STRING'); // HTMLhtml, graphique ...
			$trie = $jinput->get('trie', '', 'STRING'); // Trie ou pas
			$mescolonnes = $jinput->get('mescolonnes', Array (0 => 1), 'ARRAY'); // Colonnes selectionnées (la premiere par defaut)

			// Recup paramètres utilisateurs en cookies	pour l'instance ou en url
			$id_cookie = $user->username.'-';
			$instance = $jinput->get('instance', '', 'STRING');
			if ($instance == '' && isset($_COOKIE[$id_cookie.'instance']) && $_COOKIE[$id_cookie.'instance'] != '')
				$instance = $_COOKIE[$id_cookie.'instance'];
			if ($instance == '')
				$instance = '1';

			// Format dates
			$date_fmt_tab = explode(' ', JText::_('BSBNR_DATE_CALENDAR'));
			$date_fmt = $date_fmt_tab[0]; // Date sans heures
			$date_fmt_hms = JText::_('BSBNR_DATE_CALENDAR');

			// Date début
			$date_deb = trim($jinput->get('jform_date_deb', '', 'STRING'));
			if (($date_deb_us = $this->verif_date($date_deb, $date_fmt))) { // Test et retourne format us si ok, sinon nul
				$date_deb_us = $date_deb_us.' 00:00:00';
			} else {
				$date_deb = date($date_fmt, mktime(0, 0, 0, 1, 1));
				$date_deb_us = date('Y').'-01-01 00:00:00';
			}

			// Date fin
			$date_fin = trim($jinput->get('jform_date_fin', '', 'STRING'));
			if ($date_fin_us = $this->verif_date($date_fin, $date_fmt)) { // Test et retourne format us si ok, sinon nul
				$date_fin_us = $date_fin_us.' 23:59:59';
			} else {
				$date_fin = null;
				$date_fin_us = null;
			}

			// Données
			$this->data = '';
			$this->param = '';

			$plugin_file = JPATH_COMPONENT_SITE.'/plugin/plug_data_default/data_default.php'; // Model
			if (@file_exists($plugin_file))
				require_once $plugin_file;
			$plugin_file = JPATH_COMPONENT_SITE.'/plugin/plug_'.$plugin.'/'.$plugin.'.php'; // Plugin
			if (@file_exists($plugin_file)) {
				require_once $plugin_file;

				// Nom plugin
				$nom_class = 'BS_'.$plugin;
				$mon_obj = new $nom_class;

				if ($mode == '')
					$mode = $mon_obj->mode_defaut;
				if ($trie == '')
					$trie = $mon_obj->trie_defaut;
				$mon_obj->aff_import = $pparams->get('data_user_import', 1);
				$mon_obj->aff_export = $pparams->get('data_user_export', 1);

				// Controle typage des saisies possibles en url
				$mode = intval($mode);
				$trie = intval($trie);
				$archive_data_user_nb_print = intval($archive_data_user_nb_print);
				$instance = intval($instance);

				$mon_obj->val_instance = $instance;

				// Actions :-)
				$madata = $mon_obj->load_data_format($user->id, $instance, $mode, $archive_data_user_nb_print, $date_deb_us, $date_fin_us);
				$tab_mode = $mon_obj->tab_mode();
				$mon_obj->aff_tab_select_ckeck = $mescolonnes;

				// Datas
				$this->data = $mon_obj->data_aff($mode, $madata, $trie, $archive_data_user_nb_print, $date_fmt_hms); // Données ordre décroissants si affichés en 'texte'

				// Param
				if ($this->data != '')
					$this->param = $mon_obj->param_aff($nb_instance, $instance, $date_deb, $date_fin, $tab_mode, $mode, $trie, $archive_data_user_nb_print, $date_fmt); // Les paramètres par défaut

				// Import export
				if ($this->data != '')
					$this->impexp = $mon_obj->impexp_aff();
				else
					$this->impexp = null;
			}
		}

		if (!$this->data)
			$this->data = JText::_('BSBNR_MSG_DATA_EMPTY');

		parent::display($tpl);
	}

	function display_module($module_name, $style = 'none') {
		BS_helper::display_module($module_name, $style);
	}

	// Verifie la date, la retourne au format US si ok et null si ko
	function verif_date($madate, $date_fmt) {

		$madate_tab = explode(' ', $madate);
		$madate_day = $madate_tab[0]; // $madate sans heure (partie gauche)

		// Vérification que la date est une date correcte et transformation de format

		if ($date = DateTime::createFromFormat($date_fmt, $madate_day))
			$madate_out = $date->format('Y-m-d');
		else
			$madate_out = null;

		// Ajouter un test : date recu = (transforme au format apres transformation format us)

		// Sinon date-heure actuelle par défaut
		if ($madate_out == '1970-01-01' || $madate_out == '0000-00-00')
			$madate_out = null;

		return $madate_out;
	}
}
?>
