<?php
/**
* @version $Id: doc-fr.php $
* @version		1.4.2 23/08/2019
* @package		bsbanner
* @author       Bernard Saulmé
* @copyright	Copyright (C) 2008 - 2019 Bernard Saulmé
* @license      GNU/GPLv3 http://www.gnu.org/licenses/gpl-3.0.html
*/

defined('_JEXEC') or die;

$document = JFactory::getDocument();
$document->addStyleSheet(JURI::root().'components/com_bsbanner/assets/bsbanner.css');
?>
<h2>Données et création de Vignette</h2>
<div class="bsbanner">
	<br />
	<div>
	Vous pouvez créer des vignettes avec des libellés et des valeurs que vous fournissez.
	Cette vignette pourra être mise dans votre signature, les forums, ...
	</div>
	<br />
	<h4>Affichage</h4>
	<p>Pour afficher votre vignette et voir le lien.</p>
	<br />
	<h4>Saisie</h4>
	<div>
	<p>Pour saisir les données :</p>
	<ul>
	<li>Les libellés pré-affichés sont ceux qui comportent des seuils avec des couleurs pour la création des vignettes.</li>
	<li>Les libellés peuvent être changés d'ordre.</li>
	<li>Les libellés peuvent être remplacés.</li>
	<li>Les 4 premiers caractères sont pris en compte pour la vignette.</li>
	<li>Seuls les libellés avec des valeurs sont utilisés.</li>
	</ul>
	<br />
	<p>Pour modifier les paramètres (clic sur '+/-') :</p>
	<ul>
	<li>Changer la couleur du texte (codage RGB).</li>
	<li>Changer la couleur du fond (codage RGB).</li>
	<li>Fond transparent.</li>
	<?php if ($this->image_fond_util > 0) { ?>
	<li>Fichier pour une image de fond de vignette.</li>
	<?php } ?>
	<?php if ($this->image_fond_util_url > 0) { ?>
	<li>Url pour une image de fond de vignette.</li>
	<?php } ?>
	<?php if ($this->archive_data_user_cookie == 1) { ?>
	<li>Mémoriser les dernières données saisies (en cookies).</li>
	<?php } ?>
	</ul>
	</div>
	<br />
	<h4>Suppression</h4>
	<p>Pour supprimer votre vignette définitivement.</p>


	<?php if ($this->plugin != 'data_default') { ?>
	<br />
	<h4>Données</h4>
	<ul>
	<li>Les données sont conservées pour un maximum de <?php echo $this->archive_data_user_days; ?> jours.</li>
	<li>Un maximum de <?php echo $this->archive_data_user_nb; ?> lignes de saisies sont conservées.</li>
	</ul>
	<?php } ?>
	</div>
	<br />
	<div class="bsfooter">
	<?php echo $this->version.'<br />';?>
	</div>
</div>