<?php
/**
* @version $Id: view.html.php $
* @version		1.4.2 23/08/2019
* @package		bsbanner
* @author       Bernard Saulmé
* @copyright	Copyright (C) 2008 - 2019 Bernard Saulmé
* @license      GNU/GPLv3 http://www.gnu.org/licenses/gpl-3.0.html
*/

defined('_JEXEC') or die;

require_once JPATH_COMPONENT_SITE.'/helpers/helper.php';

class BsbannerViewEdit extends JViewLegacy
{
	function display($tpl = null)
	{
		$jinput = JFactory::getApplication()->input;

		// User info
		$user = JFactory::getuser();
		$this->username = $user->username;

		// User identified (sec.)
		if (isset($user->username)) {
			require_once JPATH_COMPONENT_SITE.'/models/bsbanner.php';

			// Config
			$pparams = JComponentHelper::getParams('com_bsbanner');

			$this->edit_link = $pparams->get('edit_link', 1);
			$this->nb_ligne_saisie = $pparams->get('nb_ligne_saisie', 20);
			$inclure_val_param = $pparams->get('inclure_val_param', 1);
			$this->nb_instance = $pparams->get('nb_instance', 1);
			$this->plugin = $pparams->get('plugin', 'data_default');
			$this->section_top = $pparams->get('section_top', '');
			$this->section_bottom = $pparams->get('section_bottom', '');

			// Date
			$this->edit_date = $pparams->get('edit_date', 1);
			$this->date_tmp = date(JText::_('BSBNR_DATE_CALENDAR'));

			// Le fichier des parametres couleurs/libelle (pour afficher des valeurs par defaut)
			$fichier_include = 'components/com_bsbanner/models/#ref-image.conf2.php';
			// Si fichier de données à inclure, alors charge sinon donnees vides
			$maconf = array();
			if ($inclure_val_param == 1 && @file_exists($fichier_include)) {
				require_once $fichier_include;
			} else {
				$maconf = array();
				$maconf[1]['id'] = ''; // pour avoir une ligne, même vide :-)
				$maconf[1]['img'] = 1;
			}
			// Constitution de la liste unique de libellés à afficher à partir de la configuration
			$nb_conf = count($maconf);
			for ($i = 1 ; $i <= $nb_conf ; ++$i) {
				$maconf_unique0[ $maconf[$i]['id'] ] = $maconf[$i]['img'];
			}
			$i = 1;
			foreach ($maconf_unique0 as $key=>$val) {
				$maconf_unique1[$i]['id'] = $key;
				$maconf_unique1[$i]['img'] = $val;
				$i++;
			}
			$this->maconf = $maconf_unique1;

			// Parametres image (config admin)
			$this->maparam = BsbannerModelBsbanner::charge_param();

			// Instance
			$this->maparam["instance"] = $jinput->get('instance', '', 'STRING');

			// Recup paramètres utilisateurs en cookies
			if ($pparams->get('archive_data_user_cookie','1') == '1') {
				$this->id_cookie = $user->username.'-';

				if ($this->maparam['instance'] == '' && isset($_COOKIE[$this->id_cookie.'instance']) && $_COOKIE[$this->id_cookie.'instance'] != '')
					$this->maparam['instance'] = $_COOKIE[$this->id_cookie.'instance'];
				if ($this->maparam['instance'] == '')
					$this->maparam['instance'] = '1';

				$this->id_cookie = $user->username.'-'.$this->maparam['instance'].'-';
				if (isset($_COOKIE[$this->id_cookie.'image_couleur_texte']) && $_COOKIE[$this->id_cookie.'image_couleur_texte'] != '')
					$this->maparam['image_couleur_texte'] = $_COOKIE[$this->id_cookie.'image_couleur_texte'];
				if (isset($_COOKIE[$this->id_cookie.'image_couleur_fond']) && $_COOKIE[$this->id_cookie.'image_couleur_fond'] != '')
					$this->maparam['image_couleur_fond'] = $_COOKIE[$this->id_cookie.'image_couleur_fond'];
				if (isset($_COOKIE[$this->id_cookie.'image_transparente']) && $_COOKIE[$this->id_cookie.'image_transparente'] != '')
					$this->maparam['image_transparente'] = $_COOKIE[$this->id_cookie.'image_transparente'];
				if (isset($_COOKIE[$this->id_cookie.'image_couleur_fond_url']) && $_COOKIE[$this->id_cookie.'image_couleur_fond_url'])
					$this->maparam['image_couleur_fond_url'] = $_COOKIE[$this->id_cookie.'image_couleur_fond_url'];
			} else if ($this->maparam['instance'] == '') // Rien en param et pas de cookies !
				$this->maparam['instance'] = '1';

			// Nom fichier vignette
			$this->img_file_rep = $pparams->get('fichier_image_rep', 'images/').$user->username.'-'.$this->maparam["instance"].'.png';
			if (!@file_exists($this->img_file_rep))
				$this->img_file_rep = null;
		}

		parent::display($tpl);
	}

	function display_module($module_name, $style = 'none') {
		BS_helper::display_module($module_name, $style);
	}
}

?>
